/*
 * 
 * Vericon version 4.3. Generated Sat Sep 12 12:46:55 2015
 * Auto generated testbench
 *
 */
 
// Freeware September 2015, Fen Logic Ltd.
// This code is free and is delivered 'as is'.
// It comes without any warranty, to the extent permitted by applicable law.
// There are no restrictions to any use or re-use of this code
// in any form or shape. It would be nice if you keep my company name
// in the source or modified source code but even that is not
// required as I can't check it anyway.
// But the code comes with no warranties or guarantees whatsoever.

module tpm_test;

localparam WCLK_PERIOD=110;
localparam RCLK_PERIOD=100;

localparam WIDTH= 8; // width in bits
localparam L2D  = 8; // Log 2 Depth, 8 = 256 deep 
                     // Simulation parameters
localparam CLEAR= 0;
localparam FILE = "../tb/xpm_test.pattern";
localparam CHECK= 1;


reg              wclk; // write clock                
reg              write; // write access 
reg  [L2D-1:0]   wadrs; // write address
reg  [WIDTH-1:0] wdata; // write data
   
reg              rclk; // read clock                
reg              read; // read access
reg  [L2D-1:0] radrs; // read address
wire [WIDTH-1:0] rdata;


// testbench
reg    we,re;
   initial
   begin

      write  = 1'b0;
      wadrs  = 'b0;
      wdata  = 'b0;
   
      read   = 1'b0;
      radrs  = 'b0;
      we = 0;
      re = 0;
      #5;
      we = 1'b1;
      #5000;
      re = 1'b1;
      #30000;
      // Text clash 
      we = 1'b0;
      re = 1'b0;
      wadrs  = 'b0;
      radrs  = 'b0;
      #500;
      we = 1'b1;
      #100;
      re = 1'b1;
      #5000;
       $stop;  
   end


tpm

   #(
      .WIDTH (WIDTH),  // width in bits
      .L2D   (L2D)  ,  // Log 2 Depth, 8 = 256 deep 
                         // Simulation parameters
      .CLEAR (CLEAR),
      .FILE  (FILE),
      .CHECK (CHECK) 
   ) // parameters
tpm_0 (

      .wclk (wclk),  // write clock                
      .write(write), // write access 
      .wadrs(wadrs), // write address
      .wdata(wdata), // write data
   
      .rclk (rclk),  // read clock                
      .read (read),  // read access
      .radrs(radrs), // read address
      .rdata(rdata) 
   );



   // Write actions
   always @(posedge wclk)
   begin
      if (we)
      begin
         wadrs <= wadrs + 1;
         wdata <= wdata + 1;
         write <= ~write;
      end
   end

   // Read actions
   always @(posedge rclk)
   begin
      if (re)
      begin
         radrs <= radrs + 1;
         read  <= ~read;
      end
   end
   // Generate write clock.
   initial
   begin
      wclk = 1'b0;
      forever
         #(WCLK_PERIOD/2) wclk = ~wclk;
   end
   // Generate read clock.
   initial
   begin
      rclk = 1'b0;
      forever
         #(RCLK_PERIOD/2) rclk = ~rclk;
   end

endmodule
